package betterwithmods.common.registry;

import betterwithmods.util.InvUtils;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.item.crafting.Ingredient;
import net.minecraft.util.NonNullList;
import net.minecraft.util.ResourceLocation;
import net.minecraft.world.World;
import net.minecraftforge.oredict.OreDictionary;
import net.minecraftforge.registries.IForgeRegistryEntry;

import java.util.Random;
import java.util.function.Predicate;

/**
 * Created by primetoxinz on 6/27/17.
 */
public class ToolDamageRecipe extends IForgeRegistryEntry.Impl<IRecipe> implements IRecipe {
    private ResourceLocation group;
    private Predicate<ItemStack> isTool;
    private ItemStack result;
    private Ingredient input;

    public ToolDamageRecipe(ResourceLocation group, ItemStack result, Ingredient input, Predicate<ItemStack> isTool) {
        this.group = group;
        this.isTool = isTool;
        this.result = result;
        this.input = input;
    }

    public boolean isMatch(IInventory inv, World world) {
        boolean hasTool = false, hasInput = false;
        for (int x = 0; x < inv.func_70302_i_(); x++) {
            boolean inRecipe = false;
            ItemStack slot = inv.func_70301_a(x);

            if (!slot.func_190926_b()) {
                if (isTool.test(slot)) {
                    if (!hasTool) {
                        hasTool = true;
                        inRecipe = true;
                    } else
                        return false;
                } else if (OreDictionary.containsMatch(true, InvUtils.asNonnullList(input.func_193365_a()), slot)) {
                    if (!hasInput) {
                        hasInput = true;
                        inRecipe = true;
                    } else
                        return false;
                }
                if (!inRecipe)
                    return false;
            }
        }
        return hasTool && hasInput;
    }

    public ItemStack getExampleStack() {
        return ItemStack.field_190927_a;
    }

    @Override
    public boolean func_77569_a(InventoryCrafting inv, World worldIn) {
        return isMatch(inv, worldIn);
    }

    @Override
    public ItemStack func_77572_b(InventoryCrafting inv) {
        return result.func_77946_l();
    }

    @Override
    public boolean func_194133_a(int width, int height) {
        return width * height >= 2;
    }

    @Override
    public ItemStack func_77571_b() {
        return result.func_77946_l();
    }

    @Override
    public NonNullList<ItemStack> func_179532_b(InventoryCrafting inv) {
        NonNullList<ItemStack> stacks = NonNullList.func_191197_a(inv.func_70302_i_(), ItemStack.field_190927_a);
        for (int i = 0; i < stacks.size(); i++) {
            ItemStack stack = inv.func_70301_a(i);
            if (!stack.func_190926_b() && isTool.test(stack)) {
                ItemStack copy = stack.func_77946_l();
                if (!copy.func_96631_a(1, new Random(), null)) {
                    stacks.set(i, copy.func_77946_l());
                }
            }
        }
        return stacks;
    }

    public String func_193358_e() {
        if (group != null)
            return group.toString();
        return "";
    }

    @Override
    public NonNullList<Ingredient> func_192400_c() {
        NonNullList<Ingredient> ingredients = NonNullList.func_191196_a();
        ingredients.add(input);
        ingredients.add(new IngredientTool(isTool, getExampleStack()));
        return ingredients;
    }
}
