package betterwithmods.module.hardcore;

import betterwithmods.common.items.ItemMaterial;
import betterwithmods.module.Feature;
import betterwithmods.module.ModuleLoader;
import betterwithmods.module.gameplay.CrucibleRecipes;
import betterwithmods.module.gameplay.MetalReclaming;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.oredict.OreDictionary;
import net.minecraftforge.oredict.ShapedOreRecipe;

/**
 * Created by tyler on 4/20/17.
 */
public class HCDiamond extends Feature {
    @Override
    public String getFeatureDescription() {
        return "Makes it so diamonds have to me made into an ingot alloy to be used in certain recipes";
    }

    @Override
    public void init(FMLInitializationEvent event) {
        addHardcoreRecipe(new ShapedOreRecipe(null, new ItemStack(Items.field_151056_x), "DD", "DS", " S", 'D', ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT), 'S', "stickWood").setMirrored(true).setRegistryName(new ResourceLocation("minecraft", "diamond_axe")));
        addHardcoreRecipe(new ShapedOreRecipe(null, new ItemStack(Items.field_151012_L), "DD", " S", " S", 'D', ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT), 'S', "stickWood").setMirrored(true).setRegistryName(new ResourceLocation("minecraft", "diamond_hoe")));
        addHardcoreRecipe(new ShapedOreRecipe(null, new ItemStack(Items.field_151046_w), "DDD", " S ", " S ", 'D', ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT), 'S', "stickWood").setRegistryName(new ResourceLocation("minecraft", "diamond_pickaxe")));
        addHardcoreRecipe(new ShapedOreRecipe(null, new ItemStack(Items.field_151047_v), "D", "S", "S", 'D', ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT), 'S', "stickWood").setRegistryName(new ResourceLocation("minecraft", "diamond_shovel")));
        addHardcoreRecipe(new ShapedOreRecipe(null, new ItemStack(Items.field_151048_u), "D", "D", "S", 'D', ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT), 'S', "stickWood").setRegistryName(new ResourceLocation("minecraft", "diamond_sword")));
        addHardcoreRecipe(new ShapedOreRecipe(null, new ItemStack(Items.field_151161_ac), "DDD", "D D", 'D', ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT)).setRegistryName(new ResourceLocation("minecraft", "diamond_helmet")));
        addHardcoreRecipe(new ShapedOreRecipe(null, new ItemStack(Items.field_151163_ad), "D D", "DDD", "DDD", 'D', ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT)).setRegistryName(new ResourceLocation("minecraft", "diamond_chestplate")));
        addHardcoreRecipe(new ShapedOreRecipe(null, new ItemStack(Items.field_151173_ae), "DDD", "D D", "D D", 'D', ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT)).setRegistryName(new ResourceLocation("minecraft", "diamond_leggings")));
        addHardcoreRecipe(new ShapedOreRecipe(null, new ItemStack(Items.field_151175_af), "D D", "D D", 'D', ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT)).setRegistryName(new ResourceLocation("minecraft", "diamond_boots")));

        if (ModuleLoader.isFeatureEnabled(MetalReclaming.class) && MetalReclaming.reclaimCount > 0) {
            CrucibleRecipes.addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT, 3),new Object[]{new ItemStack(Items.field_151056_x, 1, OreDictionary.WILDCARD_VALUE)});
            CrucibleRecipes.addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT, 2),new Object[]{new ItemStack(Items.field_151012_L, 1, OreDictionary.WILDCARD_VALUE)});
            CrucibleRecipes.addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT, 3),new Object[]{new ItemStack(Items.field_151046_w, 1, OreDictionary.WILDCARD_VALUE)});
            CrucibleRecipes.addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT, 1),new Object[]{new ItemStack(Items.field_151047_v, 1, OreDictionary.WILDCARD_VALUE)});
            CrucibleRecipes.addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT, 2),new Object[]{new ItemStack(Items.field_151048_u, 1, OreDictionary.WILDCARD_VALUE)});
            CrucibleRecipes.addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT, 5),new Object[]{new ItemStack(Items.field_151161_ac, 1, OreDictionary.WILDCARD_VALUE)});
            CrucibleRecipes.addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT, 8),new Object[]{new ItemStack(Items.field_151163_ad, 1, OreDictionary.WILDCARD_VALUE)});
            CrucibleRecipes.addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT, 7),new Object[]{new ItemStack(Items.field_151173_ae, 1, OreDictionary.WILDCARD_VALUE)});
            CrucibleRecipes.addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT, 4),new Object[]{new ItemStack(Items.field_151175_af, 1, OreDictionary.WILDCARD_VALUE)});
        }
    }

    public IRecipe addHardcoreRecipe(IRecipe recipe) {
        return registerHardcoreRecipe("HCDiamond", recipe);
    }

    @Override
    public boolean requiresMinecraftRestartToEnable() {
        return true;
    }
}
