package betterwithmods.module.hardcore.hchunger;

import betterwithmods.client.gui.GuiHunger;
import betterwithmods.common.BWMItems;
import betterwithmods.common.blocks.BlockRawPastry;
import betterwithmods.module.CompatFeature;
import betterwithmods.module.gameplay.CauldronRecipes;
import betterwithmods.module.gameplay.KilnRecipes;
import betterwithmods.network.MessageGuiShake;
import betterwithmods.network.NetworkHandler;
import betterwithmods.util.player.FatPenalty;
import betterwithmods.util.player.HungerPenalty;
import betterwithmods.util.player.PlayerHelper;
import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.AbstractClientPlayer;
import net.minecraft.client.model.ModelBiped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.entity.RenderPlayer;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.init.MobEffects;
import net.minecraft.item.ItemFood;
import net.minecraft.item.ItemStack;
import net.minecraft.network.datasync.DataParameter;
import net.minecraft.network.datasync.DataSerializers;
import net.minecraft.network.datasync.EntityDataManager;
import net.minecraft.util.DamageSource;
import net.minecraft.util.FoodStats;
import net.minecraft.world.World;
import net.minecraftforge.client.event.FOVUpdateEvent;
import net.minecraftforge.client.event.RenderGameOverlayEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.entity.EntityEvent;
import net.minecraftforge.event.entity.living.LivingEntityUseItemEvent;
import net.minecraftforge.event.entity.living.LivingEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.eventhandler.Event;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.PlayerEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import squeek.applecore.api.AppleCoreAPI;
import squeek.applecore.api.food.FoodEvent;
import squeek.applecore.api.food.FoodValues;
import squeek.applecore.api.hunger.ExhaustionEvent;
import squeek.applecore.api.hunger.HealthRegenEvent;
import squeek.applecore.api.hunger.HungerEvent;
import squeek.applecore.api.hunger.StarvationEvent;

/**
 * Created by primetoxinz on 6/20/17.
 */
public class HCHunger extends CompatFeature {
    public HCHunger() {
        super("applecore");
    }

    @Override
    public void init(FMLInitializationEvent event) {

        FoodHelper.registerFood(new ItemStack(Items.field_151147_al), 12);
        FoodHelper.registerFood(new ItemStack(Items.field_179558_bo), 12);
        FoodHelper.registerFood(new ItemStack(Items.field_151076_bf), 9);
        FoodHelper.registerFood(new ItemStack(Items.field_179561_bm), 9);
        FoodHelper.registerFood(new ItemStack(Items.field_151115_aP), 9);
        FoodHelper.registerFood(new ItemStack(Items.field_151083_be), 15);
        FoodHelper.registerFood(new ItemStack(Items.field_151157_am), 15);
        FoodHelper.registerFood(new ItemStack(Items.field_179559_bp), 15);
        FoodHelper.registerFood(new ItemStack(Items.field_151077_bg), 12);
        FoodHelper.registerFood(new ItemStack(Items.field_179557_bn), 12);
        FoodHelper.registerFood(new ItemStack(Items.field_179566_aV), 12);
        FoodHelper.registerFood(new ItemStack(Items.field_151070_bp), 6);
        FoodHelper.registerFood(new ItemStack(Items.field_151078_bh), 9);
        FoodHelper.registerFood(new ItemStack(Items.field_151009_A), 9);
        FoodHelper.registerFood(new ItemStack(Items.field_185165_cW), 9);
        FoodHelper.registerFood(new ItemStack(Items.field_179560_bq), 30);
        FoodHelper.registerFood(new ItemStack(Items.field_151127_ba), 2);
        FoodHelper.registerFood(new ItemStack(Items.field_151034_e), 3);
        FoodHelper.registerFood(new ItemStack(Items.field_151174_bG), 3);
        FoodHelper.registerFood(new ItemStack(Items.field_151172_bF), 3);
        FoodHelper.registerFood(new ItemStack(Items.field_185164_cV), 3);
        FoodHelper.registerFood(new ItemStack(Items.field_151168_bH), 6);
        FoodHelper.registerFood(new ItemStack(Items.field_151025_P), 12);


        FoodHelper.registerFood(new ItemStack(Items.field_151153_ao), 3);
        FoodHelper.registerFood(new ItemStack(Items.field_151150_bK), 3);
        FoodHelper.registerFood(new ItemStack(BWMItems.BEEF_DINNER), 24);
        FoodHelper.registerFood(new ItemStack(BWMItems.BEEF_POTATOES), 18);
        FoodHelper.registerFood(new ItemStack(BWMItems.RAW_KEBAB), 18);
        FoodHelper.registerFood(new ItemStack(BWMItems.COOKED_KEBAB), 24);
        FoodHelper.registerFood(new ItemStack(BWMItems.CHICKEN_SOUP), 24);
        FoodHelper.registerFood(new ItemStack(BWMItems.CHOWDER), 15);
        FoodHelper.registerFood(new ItemStack(BWMItems.HEARTY_STEW), 30);
        FoodHelper.registerFood(new ItemStack(BWMItems.PORK_DINNER), 24);
        FoodHelper.registerFood(new ItemStack(BWMItems.RAW_EGG), 6);
        FoodHelper.registerFood(new ItemStack(BWMItems.COOKED_EGG), 9);
        FoodHelper.registerFood(new ItemStack(BWMItems.RAW_SCRAMBLED_EGG), 12);
        FoodHelper.registerFood(new ItemStack(BWMItems.COOKED_SCRAMBLED_EGG), 15);
        FoodHelper.registerFood(new ItemStack(BWMItems.RAW_OMELET), 9);
        FoodHelper.registerFood(new ItemStack(BWMItems.COOKED_OMELET), 12);
        FoodHelper.registerFood(new ItemStack(BWMItems.HAM_AND_EGGS), 18);
        FoodHelper.registerFood(new ItemStack(BWMItems.TASTY_SANDWICH), 18);
        FoodHelper.registerFood(new ItemStack(BWMItems.CREEPER_OYSTER), 6);
        FoodHelper.registerFood(new ItemStack(BWMItems.KIBBLE), 9);
        FoodHelper.registerFood(new ItemStack(BWMItems.WOLF_CHOP), 12);
        FoodHelper.registerFood(new ItemStack(BWMItems.COOKED_WOLF_CHOP), 15);
        FoodHelper.registerFood(new ItemStack(BWMItems.MYSTERY_MEAT), 9);
        FoodHelper.registerFood(new ItemStack(BWMItems.COOKED_MYSTERY_MEAT), 12);

        FoodHelper.registerFood(new ItemStack(BWMItems.DONUT), 3, 3, true);
        FoodHelper.registerFood(new ItemStack(BWMItems.APPLE_PIE), 12, 15, true);
        FoodHelper.registerFood(new ItemStack(Items.field_151106_aX), 3, 1, true);
        FoodHelper.registerFood(new ItemStack(Items.field_151158_bO), 12, 15, true);
        FoodHelper.registerFood(new ItemStack(BWMItems.CHOCOLATE), 6, 3, true);


        //TODO
//        BWMRecipes.removeRecipes(Items.MUSHROOM_STEW, 0);
//        BWMRecipes.removeRecipes(Items.CAKE, 0);
//        BWMRecipes.removeRecipes(Items.COOKIE, 0);
//        BWMRecipes.removeRecipes(Items.PUMPKIN_PIE, 0);
//        BWMRecipes.removeRecipes(Items.RABBIT_STEW, 0);
//        BWMRecipes.removeRecipes(Items.BEETROOT_SOUP, 0);

        GameRegistry.addSmelting(BlockRawPastry.getStack(BlockRawPastry.EnumType.COOKIE), new ItemStack(Items.field_151106_aX, 8), 0.1F);
        GameRegistry.addSmelting(BlockRawPastry.getStack(BlockRawPastry.EnumType.PUMPKIN), new ItemStack(Items.field_151158_bO, 1), 0.1F);
        GameRegistry.addSmelting(BlockRawPastry.getStack(BlockRawPastry.EnumType.APPLE), new ItemStack(BWMItems.APPLE_PIE, 1), 0.1F);

        KilnRecipes.addKilnRecipe(BlockRawPastry.getStack(BlockRawPastry.EnumType.COOKIE), new ItemStack(Items.field_151106_aX, 8));
        KilnRecipes.addKilnRecipe(BlockRawPastry.getStack(BlockRawPastry.EnumType.PUMPKIN), new ItemStack(Items.field_151158_bO, 1));
        KilnRecipes.addKilnRecipe(BlockRawPastry.getStack(BlockRawPastry.EnumType.APPLE), new ItemStack(BWMItems.APPLE_PIE, 1));

        CauldronRecipes.addCauldronRecipe(new ItemStack(Items.field_151009_A), new ItemStack(Items.field_151133_ar), new Object[]{new ItemStack(Blocks.field_150338_P, 3), new ItemStack(Items.field_151117_aB), new ItemStack(Items.field_151054_z)});
        CauldronRecipes.addCauldronRecipe(new ItemStack(Items.field_185165_cW), new Object[]{new ItemStack(Items.field_185164_cV, 6), new ItemStack(Items.field_151054_z)});
        CauldronRecipes.addCauldronRecipe(new ItemStack(Items.field_179560_bq, 5), new Object[]{Items.field_179559_bp, Items.field_151172_bF, Items.field_151168_bH, new ItemStack(Items.field_151054_z, 5), new ItemStack(Blocks.field_150337_Q, 3), "foodFlour"});
    }

    @Override
    public void disabledInit(FMLInitializationEvent event) {
        GameRegistry.addSmelting(BlockRawPastry.getStack(BlockRawPastry.EnumType.COOKIE), new ItemStack(Items.field_151106_aX, 16), 0.1F);
        GameRegistry.addSmelting(BlockRawPastry.getStack(BlockRawPastry.EnumType.PUMPKIN), new ItemStack(Items.field_151158_bO, 2), 0.1F);
        KilnRecipes.addKilnRecipe(BlockRawPastry.getStack(BlockRawPastry.EnumType.COOKIE), new ItemStack(Items.field_151106_aX, 16));
        KilnRecipes.addKilnRecipe(BlockRawPastry.getStack(BlockRawPastry.EnumType.PUMPKIN), new ItemStack(Items.field_151158_bO, 2));
    }

    @Override
    public void preInitClient(FMLPreInitializationEvent event) {
        MinecraftForge.EVENT_BUS.register(ClientSide.class);
        super.preInitClient(event);
    }

    @SubscribeEvent
    public void respawn(PlayerEvent.PlayerRespawnEvent event) {
        if (event.isEndConquered())
            return;
        if (event.player != null) {
            AppleCoreAPI.mutator.setSaturation(event.player, 0);
            AppleCoreAPI.mutator.setHunger(event.player, AppleCoreAPI.accessor.getMaxHunger(event.player));
        }
    }

    //Changes food to correct value.
    @SubscribeEvent
    public void modifyFoodValues(FoodEvent.GetFoodValues event) {
        FoodHelper.getFoodValue(event.food).ifPresent(v -> event.foodValues = v);
    }


    //Stops Eating if Hunger Effect is active
    @SubscribeEvent
    public void onFood(LivingEntityUseItemEvent.Start event) {
        if (event.getItem().func_77973_b() instanceof ItemFood && event.getEntityLiving() instanceof EntityPlayer && PlayerHelper.isSurvival((EntityPlayer) event.getEntityLiving())) {
            if (event.getEntityLiving().func_70644_a(MobEffects.field_76438_s)) {
                event.setCanceled(true);
            }
        }
    }

    @SubscribeEvent
    public void getPlayerFoodValue(FoodEvent.GetPlayerFoodValues event) {
        FoodStats stats = event.player.func_71024_bL();
        int playerFoodLevel = stats.func_75116_a();
        int foodLevel = event.foodValues.hunger;
        float fat = (foodLevel + playerFoodLevel) - AppleCoreAPI.accessor.getMaxHunger(event.player);
        if (!FoodHelper.isDessert(event.food)) {
            if (fat < 0) {
                event.foodValues = new FoodValues(foodLevel, 0);
            } else {
                //TODO doesn't add fat currently.
                event.foodValues = new FoodValues(foodLevel, fat / 60f);
            }
        }
    }

    //Changes exhaustion to reduce food first, then fat.
    @SubscribeEvent
    public void exhaust(ExhaustionEvent.Exhausted event) {
        FoodStats stats = event.player.func_71024_bL();
        float saturation = stats.func_75115_e();
        int hunger = stats.func_75116_a();
        if (hunger > saturation) {
            event.deltaSaturation = 0;
            event.deltaHunger = -1;
        } else {
            event.deltaSaturation = -1;
            event.deltaHunger = 0;
        }
    }

    //Adds Exhaustion when Jumping and cancels Jump if too exhausted
    @SubscribeEvent
    public void onJump(LivingEvent.LivingJumpEvent event) {
        if (event.getEntityLiving() instanceof EntityPlayer) {
            EntityPlayer player = (EntityPlayer) event.getEntityLiving();
            if (!PlayerHelper.canJump(player)) {
                event.getEntityLiving().field_70159_w = 0;
                event.getEntityLiving().field_70181_x = 0;
                event.getEntityLiving().field_70179_y = 0;
            }
            player.func_71020_j(0.5f);
        }
    }

    @SubscribeEvent
    public void setMaxFood(HungerEvent.GetMaxHunger event) {
        event.maxHunger = 60;
    }

    //Chaneg speed based on Hunger
    @SubscribeEvent
    public void givePenalties(LivingEvent.LivingUpdateEvent event) {
        if (event.getEntityLiving() instanceof EntityPlayer) {
            EntityPlayer player = (EntityPlayer) event.getEntityLiving();
            PlayerHelper.changeSpeed(player, "Hunger Speed Modifier", PlayerHelper.getSpeedModifier(player));
        }
    }

    //Max Health only regen when above Peckish
    @SubscribeEvent
    public void allowHealthRegen(HealthRegenEvent.AllowRegen event) {
        event.setResult(PlayerHelper.getHungerPenalty(event.player) == HungerPenalty.NO_PENALTY ? Event.Result.ALLOW : Event.Result.DENY);
    }

    //Change Health Regen speed to take 30 seconds
    @SubscribeEvent
    public void healthRegenSpeed(HealthRegenEvent.GetRegenTickPeriod event) {
        event.regenTickPeriod = 600;
    }

    //Stop regen from Fat value.
    @SubscribeEvent
    public void denyFatRegen(HealthRegenEvent.AllowSaturatedRegen event) {
        event.setResult(Event.Result.DENY);
    }

    @SubscribeEvent
    public void onFOV(FOVUpdateEvent event) {
        if (!PlayerHelper.getHungerPenalty(event.getEntity()).canJump()) {

        }
    }

    private static final int EXHAUSTION_WITH_TIME_PERIOD = 600;
    private static final float EXHAUSTION_WITH_TIME_AMOUNT = 0.5F;
    private static final DataParameter<Integer> EXHAUSTION_TICK = EntityDataManager.func_187226_a(EntityPlayer.class, DataSerializers.field_187192_b);

    @SubscribeEvent
    public void entityConstruct(EntityEvent.EntityConstructing e) {
        if (e.getEntity() instanceof EntityPlayer) {
            e.getEntity().func_184212_Q().func_187214_a(EXHAUSTION_TICK, 0);
        }
    }

    public int getExhaustionTick(EntityPlayer player) {
        return player.func_184212_Q().func_187225_a(EXHAUSTION_TICK);
    }

    public void setExhaustionTick(EntityPlayer player, int tick) {
        player.func_184212_Q().func_187227_b(EXHAUSTION_TICK, tick);
    }

    @SubscribeEvent
    public void onPlayerTick(TickEvent.PlayerTickEvent event) {
        if (!event.player.field_70170_p.field_72995_K) {
            EntityPlayer player = event.player;
            if(!PlayerHelper.getHungerPenalty(player).canSprint())
                player.func_70031_b(false);
            int tick = getExhaustionTick(player);
            if (tick > EXHAUSTION_WITH_TIME_PERIOD) {
                player.func_71024_bL().func_75113_a(EXHAUSTION_WITH_TIME_AMOUNT);
                setExhaustionTick(player, 0);
            } else {
                setExhaustionTick(player, getExhaustionTick(player) + 1);
            }
        }
    }

    @SubscribeEvent
    public void onExhaustion(ExhaustionEvent.Exhausted event) {
        event.deltaHunger = -1;
        event.deltaSaturation = -1;
        System.out.println(event.deltaHunger);
    }

    //Shake Hunger bar whenever any exhaustion is given?
    @SubscribeEvent
    public void onExhaustAdd(ExhaustionEvent.ExhaustionAddition event) {
        if (event.player.field_70170_p.func_82737_E() % 20 == 0 && event.deltaExhaustion > 0.05) {
            NetworkHandler.INSTANCE.sendTo(new MessageGuiShake(), (EntityPlayerMP) event.player);
        }
    }
    @SubscribeEvent
    public void onStarve(StarvationEvent.AllowStarvation event) {
        if(event.player.func_71024_bL().func_75116_a() <= 0)
            event.setResult(Event.Result.ALLOW);
    }


    @SubscribeEvent
    public void onStarve(StarvationEvent.Starve event) {
        event.setCanceled(true);
        event.player.func_70097_a(DamageSource.field_76366_f, 1);
    }

    //TODO fix Hunger starting as vanilla 20.

    public String getFeatureDescription() {
        return "This Feature REQUIRES AppleCore!!!." +
                "Completely revamps the hunger system of Minecraft. \n" +
                "The Saturation value is replaced with Fat. \n" +
                "Fat will accumulate if too much food is consumed then need to fill the bar.\n" +
                "Fat will only be burned once the entire hunger bar is emptied \n" +
                "The more fat the slower you will walk.\n" +
                "Food Items values are also changed, while a ton of new foods are add.";
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }

    @SideOnly(Side.CLIENT)
    public static class ClientSide {

        //Replaces Hunger Gui with HCHunger
        @SubscribeEvent
        public static void replaceHungerGui(RenderGameOverlayEvent.Pre event) {
            if (event.getType() == RenderGameOverlayEvent.ElementType.FOOD) {
                event.setCanceled(true);
                GuiHunger.INSTANCE.draw();
            }
        }

        private static RenderPlayer getRenderPlayer(AbstractClientPlayer player) {
            Minecraft mc = Minecraft.func_71410_x();
            RenderManager manager = mc.func_175598_ae();
            return manager.getSkinMap().get(player.func_175154_l());
        }

        private static ModelBiped getPlayerModel(AbstractClientPlayer player) {
            return getRenderPlayer(player).func_177087_b();
        }

        public static void putFat(AbstractClientPlayer player, FatPenalty fat) {
            ModelBiped model = getPlayerModel(player);
            float scale = fat != FatPenalty.NO_PENALTY ? Math.max(0, fat.ordinal() / 4f) : 0.0f;
            model.field_78115_e = new ModelRenderer(model, 16, 16);
            model.field_78115_e.func_78790_a(-4.0F, 0, -2.0F, 8, 12, 4, scale);
        }

        public static void doFat(String playerName) {
            World world = Minecraft.func_71410_x().field_71441_e;
            EntityPlayer player = world.func_72924_a(playerName);
            FatPenalty fat = PlayerHelper.getFatPenalty(player);
            if (player != null && player instanceof AbstractClientPlayer)
                putFat((AbstractClientPlayer) player, fat);
        }

    }


}


